# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in E:\android\sdk/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

  -optimizationpasses 5

    #包明不混合大小写
    -dontusemixedcaseclassnames

    #不去忽略非公共的库类
    -dontskipnonpubliclibraryclasses

     #优化  不优化输入的类文件
    -dontoptimize

     #预校验
    -dontpreverify

     #混淆时是否记录日志
    -verbose

     # 混淆时所采用的算法
    -optimizations !code/simplification/arithmetic,!field/*,!class/merging/*

    #保护注解
    -keepattributes *Annotation*

    # 保持哪些类不被混淆
    -keep public class * extends android.app.Fragment
    -keep public class * extends android.app.Activity

    -keep public class * extends android.app.Application
    -keep public class * extends android.app.Service
    -keep public class * extends android.content.BroadcastReceiver
    -keep public class * extends android.content.ContentProvider
    -keep public class * extends android.app.backup.BackupAgentHelper
    -keep public class * extends android.preference.Preference
    -keep public class com.android.vending.licensing.ILicensingService
    -keep public class * implements java.io.Serializable
    #如果有引用v4包可以添加下面这行
    -keep public class * extends android.support.v4.app.Fragment

    #忽略警告
    -ignorewarning

    ##记录生成的日志数据,gradle build时在本项目根目录输出##

    #apk 包内所有 class 的内部结构
    -dump class_files.txt
    #未混淆的类和成员
    -printseeds seeds.txt
    #列出从 apk 中删除的代码
    -printusage unused.txt
    #混淆前后的映射
    -printmapping mapping.txt

    ########记录生成的日志数据，gradle build时 在本项目根目录输出-end######


    #####混淆保护自己项目的部分代码以及引用的第三方jar包library#######

    #-libraryjars libs/umeng-analytics-v5.2.4.jar

    #三星应用市场需要添加:sdk-v1.0.0.jar,look-v1.0.1.jar
    #-libraryjars libs/sdk-v1.0.0.jar
    #-libraryjars libs/look-v1.0.1.jar

    -keep class me.nereo.**{*;}

    -keep class com.google.**{*;}
    -keep class org.android.**{*;}

-keep class com.creative.learn_to_draw.bean.IconAd{*;}
-keep class com.creative.learn_to_draw.bean.Point{*;}
-keep class com.creative.learn_to_draw.bean.Svg{*;}
-keep class com.creative.learn_to_draw.bean.Group{*;}
-keep class com.creative.learn_to_draw.brush.*{*;}

-keep class org.greenrobot.greendao.**{*;}
-keepclassmembers class * extends org.greenrobot.greendao.AbstractDao {
*;
}
-keep class **$Properties



    #如果引用了v4或者v7包
    -dontwarn android.support.**

    ####混淆保护自己项目的部分代码以及引用的第三方jar包library-end####

    -keep public class * extends android.view.View {
        public <init>(android.content.Context);
        public <init>(android.content.Context, android.util.AttributeSet);
        public <init>(android.content.Context, android.util.AttributeSet, int);
        public void set*(...);
    }



    #保持自定义控件类不被混淆
    -keepclasseswithmembers class * {
        public <init>(android.content.Context, android.util.AttributeSet);
    }

    #保持自定义控件类不被混淆
    -keepclassmembers class * extends android.app.Activity {
       public void *(android.view.View);
    }


    #保持 Serializable 不被混淆并且enum 类也不被混淆
    -keepclassmembers class * implements java.io.Serializable {
        static final long serialVersionUID;
        private static final java.io.ObjectStreamField[] serialPersistentFields;
        !static !transient <fields>;
        !private <fields>;
        !private <methods>;
        private void writeObject(java.io.ObjectOutputStream);
        private void readObject(java.io.ObjectInputStream);
        java.lang.Object writeReplace();
        java.lang.Object readResolve();
    }

    #保持枚举 enum 类不被混淆 如果混淆报错，建议直接使用上面的 -keepclassmembers class * implements java.io.Serializable即可
    -keepclassmembers enum * {
      public static **[] values();
      public static ** valueOf(java.lang.String);
    }

    -keepclassmembers class * {
        public void *ButtonClicked(android.view.View);
    }

    -keep public class **.R$*

    #不混淆资源类
    -keepclassmembers class **.R$* {
        public static <fields>;
    }

    -keepclassmembers class * {
       public <init> (org.json.JSONObject);
    }


-keep class **.R$* {
   public *;
}

####################  以下来源于UntiyAds  #########################

    # Keep filenames and line numbers for stack traces
    -keepattributes SourceFile,LineNumberTable

    # Keep JavascriptInterface for WebView bridge
    -keepattributes JavascriptInterface

    # Keep all classes in Unity Ads package
    -keep class com.unity3d.ads.android.** {*;}
    -dontwarn com.unity3d.ads.**


#################### 以下来源于 facebook ads  #########################

# Proguard configurations in this file get packaged up in the AAR file and
# merged with the application proguard rules.

-dontwarn com.facebook.**
-keep public class com.facebook.** { *;}

#################### 以下来源于 vungle  #########################

# Proguard configurations in this file get packaged up in the AAR file and
# merged with the application proguard rules.

-dontwarn com.vungle.**
-keep class com.vungle.** { *; }
-keep class javax.inject.*
-keep class dagger.*

-keep class * implements GooglePlayServicesClient.ConnectionCallbacks {
    *;
}
-keep class * implements GooglePlayServicesClient.OnConnectionFailedListener {
    *;
}


#以下需要增加项目中特殊定义的部分内容

-keep class com.ew.sdk.SDKAgent{
  public *;
}

-keep interface com.ew.sdk.listener.*{
  *;
}

-keep abstract class com.ew.sdk.AdListener{
   *;
}

-keep abstract class com.ew.sdk.ads.AdListener{
   *;
}

-keep interface com.ew.sdk.ExitListener{
   *;
}

-keep interface com.ew.sdk.ads.listener.ExitListener{
   *;
}

-keep interface com.ew.sdk.IconClickListener{
   *;
}

-keep interface com.ew.sdk.self.IconClickListener{
   *;
}

-keep interface com.ew.sdk.TaskActiveListener{
   *;
}

-keep interface com.ew.sdk.listener.TaskActiveListener{
   *;
}

-keep abstract class com.ew.sdk.ads.listener.*{
   *;
}

-keep class com.ew.sdk.data.AdBase{
    public *;
}

-keep class com.ew.sdk.data.SelfAdData{
    public *;
}

-keep class com.ew.sdk.self.NativeAdData{
   public *;
}

-keep class com.ew.sdk.BaseApplication{
   public *;
}

-keep class com.ew.sdk.plugin.AdSize{
   public *;
}

-keep class com.ew.sdk.plugin.AdType{
   public *;
}

-keep class com.ew.sdk.self.module.**{
   public *;
}

-keep class com.ew.sdk.utils.jsbridge.**{
   public *;
}
-keep class com.ew.sdk.data.EventInfo{
   *;
}
-keep class com.ew.sdk.data.StatisticsInfo{
   *;
}
-keep class com.ew.sdk.data.TaskAdData{
   *;
}
-keep class com.ew.sdk.data.SelfImageInfo{
   *;
}

